/**=============================================
  *               NimGame v0.1
  * This software distributed under the
  * Do What The Fuck You Want to Public Licence
  * http://www.wtfpl.net/about
  *============================================*/

#include <LiquidCrystal.h>
LiquidCrystal lcd(12,11,5,4,3,2);

/* Commenter cette ligne pour l'un des deux joueurs */
#define PAIR 1

int nim;       // Le nombre de batons en jeu
int cpt = 0;   // Petite variable pour compter le nombre de tours

/* Variable pour déterminer si c'est à moi de jouer */
// A COMPLETER

void setup()
{
  int n, m;
  
  /* Initialisation de la liaison série pour le Xbee */
  // A COMPLETER
  
  /* 
   * Augmentation du TimeOut pour les appels sur le port série afin de temporiser
   * l'éxecution, c'est à dire avoir le temps de lire qque chose sur les LCD ;)
   */
  Serial.setTimeout(2000);
  
  /* Initialisation du LCD avec 8 colonnes et 2 lignes */
  // A COMPLETER
  lcd.clear();
  
  /* Temps d'attente pour permettre de démarrer les deux arduinos à peu près en meme temps */
  delay(5000);
  
  /* Initialisation du générateur aléatoire */
  randomSeed(analogRead(0));
  /* et génération d'un nombre random (ou pas) à envoyer pour le handshake */
  // A COMPLETER
  
  /* Affichage pour distinguer le joueur PAIR du joueur IMPAIR */
  #ifdef PAIR
    lcdPrint("I AM","PAIR");
  #else
    lcdPrint("I AM","ODD");
  #endif
  delay(2000);
  
  /* Affichage de ce que l'on va envoyer pour le handshake */
  // A COMPLETER
  
  /* 
   * Envoi du nombre pour le handshake avec la méthode println pour formater la chaine
   * et ajouter un caractère retour à la ligne qui permettra à l'adversaire de déterminer
   * la fin du chiffre
   */
  // A COMPLETER
  
  delay(2000);
  
  lcdPrint("Waiting", "number..");
  /* Reception du nombre de l'adversaire dans la variable m */
  // A COMPLETER

  /* Affichage de ce qu'on a reçu */
  // A COMPLETER
  
  delay(2000);
  
  /* On détermine si c'est à nous de commencer */
#ifdef PAIR
  if (/* A COMPLETER */){
    lcdPrint("n+m pair","I begin!");
#else
  if (/* A COMPLETER */){
    lcdPrint("n+m odd","I begin!");
#endif
    /* C'est mon tour */
    // A COMPLETER
    /* Si je commence, je détermine le nombre de batons de départ : random entre 20 et 40 */
    // A COMPLETER
  }else{
    lcdPrint("I don't","begin :(");
  }
  delay(2000);

}

void loop()
{
  int playerMove; // Variable pour recevoir le coup de l'adversaire
  int diff;       // Variable pour calculer le nombre de batons enlevés par l'adversaire
  
  /* Si c'est mon tour */
  if (/* A COMPLETER */){
    
    /* Calcul du nombre de batons à enlever */
    // A COMPLETER
    
    /* Affichage de ce que l'on va envoyer */
    lcdPrint("Sending","");
    lcd.print(nim);

    /* Envoi à l'adversaire */
    // A COMPLETER
    
    delay(1000);
    
    /* S'il ne reste qu'un seul baton après mon coup, j'ai gagné */
    if (/* A COMPLETER */){
      // A COMPLETER
      while(1);
    }
    
  /* Sinon si c'est à mon adversaire de jouer */
  }else{
    lcdPrint("Waiting","number..");
    
    /* Je récupère son coup sur le Serial dans la varibale playerMove */
    // A COMPLETER
    
    /* Affichage de ce qu'on a reçu */
    // A COMPLETER
    
    delay(1000);

    /* Je calcule le nombre de batons enlevés */
    diff = // A COMPLETER

    /* On met à jour la quantité de batons */
    nim = // A COMPLETER
    
    /* Si c'est le premier tour, je vérifie qu'il ne me donne pas un seul baton... */
    if (/* A COMPLETER */){
        lcdPrint("Nice try","bro !");
        while(1);
    }else{
      
      /* Vérifier le(s) cas où j'ai gagné */
      if (/* A COMPLETER */){
        lcdPrint("Yay","I win");
        while(1);
      
      /* Vérifier les cas de triche */
      }else if (/* A COMPLETER */){
        lcdPrint("Ennemy","cheated!");
        while(1);
      
      /* Sinon, Vérifier le cas où j'ai perdu */
      }else if(/* A COMPLETER */){
        lcdPrint("QQ", "I lost");
        while(1);
      }
    }
  }
  /* A chaque passage dans la loop, on change de tour */
  // A COMPLETER
  
  cpt++;
  delay(1000);
}

/* Petite fonction pour afficher 2 char* sur les deux lignes du LCD */
void lcdPrint(char *top, char *bot)
{
  lcd.clear();
  lcd.print(top);  
  lcd.setCursor(0,1);
  lcd.print(bot);
}
